#include <sys/mman.h>
#include <sys/syscall.h>
#include <unistd.h>

extern "C"
{
    // FIXME: Implement a POSIX-compliant mmap.
    void* mmap(void* addr, size_t len, int prot, int, int, off_t)
    {
        return (void*)syscall(SYS_mmap, addr, len, prot);
    }

    int munmap(void* addr, size_t len)
    {
        return (int)syscall(SYS_munmap, addr, len);
    }

    int mprotect(void* addr, size_t size, int prot)
    {
        return (int)syscall(SYS_mprotect, addr, size, prot);
    }
}